<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/BluetoothImplementations/BlueZ/include/BlueZ/DBusProxy.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_27114e8c504df5f4609f20f7d28eb6fc.html">BluetoothImplementations</a></li><li class="navelem"><a class="el" href="dir_734f87f436384b5f4d3ce6cedeff05c0.html">BlueZ</a></li><li class="navelem"><a class="el" href="dir_dcc26bf29d4b694c2f1fb3cf2aba65ed.html">include</a></li><li class="navelem"><a class="el" href="dir_6061b9c865ef17da7826af8a1f20a075.html">BlueZ</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">DBusProxy.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_d_bus_proxy_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_BLUETOOTHIMPLEMENTATIONS_BLUEZ_INCLUDE_BLUEZ_DBUSPROXY_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_BLUETOOTHIMPLEMENTATIONS_BLUEZ_INCLUDE_BLUEZ_DBUSPROXY_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_blue_z_utils_8h.html">BlueZUtils.h</a>&quot;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;gio/gunixfdlist.h&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span>bluetoothImplementations {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">namespace </span>blueZ {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html">   33</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html">DBusProxy</a> {</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a7ab2ebfdf203a7274750058fc77da362">~DBusProxy</a>();</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">static</span> std::shared_ptr&lt;DBusProxy&gt; <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a66fc1cf41f434b017ac93e5407855a40">create</a>(<span class="keyword">const</span> std::string&amp; interfaceName, <span class="keyword">const</span> std::string&amp; objectPath);</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a74615a82507e5bc8a253ce13e34246f9">callMethod</a>(</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keyword">const</span> std::string&amp; methodName,</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        GVariant* parameters = <span class="keyword">nullptr</span>,</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        GError** error = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#afb7a0400c211451c3563a56cf7f3492d">callMethodWithFDList</a>(</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keyword">const</span> std::string&amp; methodName,</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        GVariant* parameters = <span class="keyword">nullptr</span>,</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        GUnixFDList** outlist = <span class="keyword">nullptr</span>,</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        GError** error = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keyword">virtual</span> std::string <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a20347ff0cf0cbe3890ddc18c570026e7">getObjectPath</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keyword">virtual</span> GDBusProxy* <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#aa87f575cbcb462863edcbf83177ca969">get</a>();</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a290d683d76dce5e7a0e14873f638ae0b">DBusProxy</a>(GDBusProxy* proxy, <span class="keyword">const</span> std::string&amp; objectPath);</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    GDBusProxy* m_proxy;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keyword">const</span> std::string m_objectPath;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;};</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;}  <span class="comment">// namespace blueZ</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;}  <span class="comment">// namespace bluetoothImplementations</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_BLUETOOTHIMPLEMENTATIONS_BLUEZ_INCLUDE_BLUEZ_DBUSPROXY_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_html_a66fc1cf41f434b017ac93e5407855a40"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a66fc1cf41f434b017ac93e5407855a40">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::create</a></div><div class="ttdeci">static std::shared_ptr&lt; DBusProxy &gt; create(const std::string &amp;interfaceName, const std::string &amp;objectPath)</div><div class="ttdef"><b>Definition:</b> DBusProxy.cpp:49</div></div>
<div class="ttc" id="_blue_z_utils_8h_html"><div class="ttname"><a href="_blue_z_utils_8h.html">BlueZUtils.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_html_a20347ff0cf0cbe3890ddc18c570026e7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a20347ff0cf0cbe3890ddc18c570026e7">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::getObjectPath</a></div><div class="ttdeci">virtual std::string getObjectPath() const</div><div class="ttdef"><b>Definition:</b> DBusProxy.cpp:94</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_html_afb7a0400c211451c3563a56cf7f3492d"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#afb7a0400c211451c3563a56cf7f3492d">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::callMethodWithFDList</a></div><div class="ttdeci">virtual ManagedGVariant callMethodWithFDList(const std::string &amp;methodName, GVariant *parameters=nullptr, GUnixFDList **outlist=nullptr, GError **error=nullptr)</div><div class="ttdef"><b>Definition:</b> DBusProxy.cpp:76</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy</a></div><div class="ttdef"><b>Definition:</b> DBusProxy.h:33</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant</a></div><div class="ttdef"><b>Definition:</b> ManagedGVariant.h:33</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_html_a290d683d76dce5e7a0e14873f638ae0b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a290d683d76dce5e7a0e14873f638ae0b">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::DBusProxy</a></div><div class="ttdeci">DBusProxy(GDBusProxy *proxy, const std::string &amp;objectPath)</div><div class="ttdef"><b>Definition:</b> DBusProxy.cpp:39</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_html_a74615a82507e5bc8a253ce13e34246f9"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a74615a82507e5bc8a253ce13e34246f9">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::callMethod</a></div><div class="ttdeci">virtual ManagedGVariant callMethod(const std::string &amp;methodName, GVariant *parameters=nullptr, GError **error=nullptr)</div><div class="ttdef"><b>Definition:</b> DBusProxy.cpp:70</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_html_a7ab2ebfdf203a7274750058fc77da362"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#a7ab2ebfdf203a7274750058fc77da362">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::~DBusProxy</a></div><div class="ttdeci">virtual ~DBusProxy()</div><div class="ttdef"><b>Definition:</b> DBusProxy.cpp:42</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy_html_aa87f575cbcb462863edcbf83177ca969"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_proxy.html#aa87f575cbcb462863edcbf83177ca969">alexaClientSDK::bluetoothImplementations::blueZ::DBusProxy::get</a></div><div class="ttdeci">virtual GDBusProxy * get()</div><div class="ttdef"><b>Definition:</b> DBusProxy.cpp:98</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
